var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var Content = /** @class */ (function () {
    function Content() {
        this.width = 19;
        this.height = 14;
        var dpr = window.devicePixelRatio;
        this.displayCanvas = document.getElementById('display');
        this.displayCtx = this.displayCanvas.getContext('2d');
        this.displayCanvas.height = this.height;
        this.displayCanvas.width = this.width;
        //
        this.videoCanvas = document.getElementById('video'); //document.createElement('canvas') as HTMLCanvasElement;
        this.videoCtx = this.videoCanvas.getContext('2d');
        this.startCamera();
    }
    Content.prototype.startCamera = function () {
        return __awaiter(this, void 0, void 0, function () {
            var constraints, stream, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        constraints = {
                            video: {
                                width: { ideal: 4096 },
                                height: { ideal: 2160 },
                                facingMode: 'environment'
                            },
                            audio: false
                        };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, navigator.mediaDevices.getUserMedia(constraints)];
                    case 2:
                        stream = _a.sent();
                        this.video = document.createElement('video');
                        this.video.srcObject = stream;
                        this.video.height = stream.getVideoTracks()[0].getSettings().height;
                        this.video.width = stream.getVideoTracks()[0].getSettings().width;
                        this.video.play();
                        this.videoCanvas.height = this.video.height;
                        this.videoCanvas.width = this.video.width;
                        document.querySelector('#data').innerText = "".concat(this.video.width, "x").concat(this.video.height);
                        this.video.addEventListener('play', this.drawCanvas.bind(this));
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _a.sent();
                        console.error('Error accessing camera:', error_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Content.prototype.drawCanvas = function () {
        this.videoCtx.drawImage(this.video, 0, 0, this.videoCanvas.width, this.videoCanvas.height);
        this.parse();
        requestAnimationFrame(this.drawCanvas.bind(this));
    };
    Content.prototype.parse = function () {
        var rgba = this.videoCtx.getImageData(0, 0, this.videoCanvas.width, this.videoCanvas.height).data;
        var code = null;
        try {
            //@ts-ignore
            code = jsQR(rgba, this.videoCanvas.width, this.videoCanvas.height);
        }
        catch (err) {
            //
        }
        if (code !== null && code.binaryData.length === 266) {
            document.querySelector('#data').innerText = code.binaryData.toString();
            console.dir(code);
            this.display(code.binaryData);
        }
        else {
            console.log('No QR');
        }
    };
    Content.prototype.display = function (data) {
        for (this.i = 0; this.i < data.length; this.i++) {
            this.val = data[this.i];
            this.x = this.i % this.width;
            this.y = Math.floor(this.i / this.width);
            this.displayCtx.fillStyle = "rgba(".concat(this.val, ",").concat(this.val, ",").concat(this.val, ",1.0)");
            this.displayCtx.fillRect(this.x, this.y, 1, 1);
        }
    };
    return Content;
}());
(function main() {
    new Content();
})();
//# sourceMappingURL=content.js.map